$(function(){
var checkedItems = [];
$("#selection-treeview").dxTreeView({
items: products,
width: 320,
showCheckBoxesMode: "normal",
onItemSelectionChanged: function(e) {
var item = e.node;
if(isProduct(item)) {
processProduct($.extend({
category: item.parent.text
}, item));
} else {
$.each(item.items, function(index, product) {
processProduct($.extend({
category: item.text
}, product));
});
}
checkedItemsList.option("items", checkedItems);
},
itemTemplate: function(data) {
return "<div>" + data.text +
((data.price) ? (" ($" + data.price + ")") : "") +
"</div>";
}
});
var checkedItemsList = $("#checked-items").dxList({
width: 400,
items: checkedItems,
itemTemplate: function(data) {
return "<div>" + data.text + " (" +
data.category + ") - $" + data.itemData.price + "</div>";
}
}).dxList("instance");
function isProduct(data) {
return !data.items.length;
}
function processProduct(product) {
var itemIndex = -1;
$.each(checkedItems, function (index, item) {
if (item.key === product.key) {
itemIndex = index;
return false;
}
});
if(product.selected && itemIndex === -1) {
checkedItems.push(product);
} else if (!product.selected){
checkedItems.splice(itemIndex, 1);
}
}
});
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.4.1/jquery.min.js"></script>
<script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script>
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/19.2.4/css/dx.common.css" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/19.2.4/css/dx.light.css" />
<script src="https://cdn3.devexpress.com/jslib/19.2.4/js/dx.all.js"></script>
<script src="data.js"></script>
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="index.js"></script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div class="form">
<h4>Store: Super Mart of the West</h4>
<div id="selection-treeview"></div>
<div class="selected-data">
Selected Products
<div id="checked-items"></div>
</div>
</div>
</div>
</body>
</html>
.form>h4 {
margin-bottom: 20px;
}
.form>div,
#selection-treeview {
display: inline-block;
vertical-align: top;
}
#checked-items {
margin-top: 20px;
}
.selected-data {
padding: 20px;
background: #f5f5f5;
font-size: 115%;
font-weight: bold;
}
.dx-list-item-content {
padding-left: 0;
}
var products = [{
id: "1_1_1",
text: "Video Players",
items: [{
id: "1_1_1_1",
text: "HD Video Player",
price: 220
}, {
id: "1_1_1_2",
text: "SuperHD Video Player",
price: 270
}]
}, {
id: "1_1_2",
text: "Televisions",
expanded: true,
items: [{
id: "1_1_2_1",
text: "SuperLCD 42",
price: 1200
}, {
id: "1_1_2_2",
text: "SuperLED 42",
price: 1450
}, {
id: "1_1_2_3",
text: "SuperLED 50",
price: 1600
}, {
id: "1_1_2_4",
text: "SuperLCD 55",
price: 1350
}, {
id: "1_1_2_5",
text: "SuperLCD 70",
price: 4000
}]
}, {
id: "1_1_4",
text: "Projectors",
items: [{
id: "1_1_4_1",
text: "Projector Plus",
price: 550
}, {
id: "1_1_4_2",
text: "Projector PlusHD",
price: 750
}]
}];

<div class="form">
<h4>Employees</h4>
<dx-tree-view
id="treeview"
[items]="employees"
[width]="340"
[height]="320"
[showCheckBoxesMode]="showCheckBoxesMode"
[selectionMode]="selectionMode"
[selectNodesRecursive]="selectNodesRecursive"
[selectByClick]="selectByClick"
(onSelectionChanged)="treeViewSelectionChanged($event)"
(onContentReady)="treeViewContentReady($event)"
>
<div *dxTemplate="let item of 'item'">
{{ item.fullName + ' (' + item.position + ')' }}
</div>
</dx-tree-view>
<div class="selected-container">
Selected employees
<dx-list
id="selected-employees"
[width]="400"
[height]="200"
[items]="selectedEmployees"
showScrollbar="always"
>
<dxi-item *ngFor="let item of selectedEmployees">
{{ item.prefix + " " + item.fullName + " (" + item.position + ")" }}
</dxi-item>
</dx-list>
</div>
</div>
<div class="options">
<div class="caption">Options</div>
<div class="option">
<span>Show Check Boxes Mode:</span>
<dx-select-box
[items]="showCheckBoxesModes"
[value]="showCheckBoxesMode"
(onValueChanged)="showCheckBoxesModeValueChanged($event)"
></dx-select-box>
</div>
<div class="option">
<span>Selection Mode:</span>
<dx-select-box
[items]="selectionModes"
[value]="selectionMode"
[disabled]="isSelectionModeDisabled"
(onValueChanged)="selectionModeValueChanged($event)"
></dx-select-box>
</div>
<div class="option recursive-option">
<dx-check-box
text="Select Nodes Recursive"
[disabled]="isRecursiveDisabled"
[(value)]="selectNodesRecursive"
></dx-check-box>
</div>
<div class="option">
<dx-check-box
text="Select By Click"
[(value)]="selectByClick"
></dx-check-box>
</div>
</div>
import { NgModule, Component, Pipe, PipeTransform, enableProdMode, ViewChild } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { DxTreeViewModule, DxListModule, DxTemplateModule, DxCheckBoxModule, DxSelectBoxModule, DxTreeViewComponent } from 'devextreme-angular';
import { Service, Employee } from './app.service';
@Pipe({ name: 'title' })
export class TitlePipe implements PipeTransform {
transform(item: any): string {
return item.text + (item.price ? ' ($' + item.price + ')' : '');
}
}
if(!/localhost/.test(document.location.host)) {
enableProdMode();
}
@Component({
selector: 'demo-app',
templateUrl: 'app/app.component.html',
styleUrls: ['app/app.component.css'],
providers: [Service],
preserveWhitespaces: true
})
export class AppComponent {
@ViewChild(DxTreeViewComponent, { static: false }) treeView: DxTreeViewComponent;
employees: Employee[];
selectedEmployees: Employee[] = [];
showCheckBoxesModes: string[] = ["normal", "selectAll", "none"];
showCheckBoxesMode: string = this.showCheckBoxesModes[0];
selectionModes: string[] = ["multiple", "single"];
selectionMode: string = this.selectionModes[0];
selectNodesRecursive: boolean = true;
selectByClick: boolean = false;
isRecursiveDisabled: boolean = false;
isSelectionModeDisabled: boolean = false;
constructor(service: Service) {
this.employees = service.getEmployees();
}
treeViewSelectionChanged(e) {
this.syncSelection(e.component);
}
treeViewContentReady(e) {
this.syncSelection(e.component);
}
syncSelection(treeView) {
const selectedEmployees = treeView.getSelectedNodes()
.map(node => node.itemData);
this.selectedEmployees = selectedEmployees;
}
showCheckBoxesModeValueChanged(e) {
this.showCheckBoxesMode = e.value;
this.isSelectionModeDisabled = e.value === 'selectAll';
if(e.value === 'selectAll') {
this.selectionMode = "multiple";
this.isRecursiveDisabled = false;
}
}
selectionModeValueChanged(e) {
this.selectionMode = e.value;
this.isRecursiveDisabled = e.value === 'single';
if(e.value === 'single') {
this.selectNodesRecursive = false;
this.treeView.instance.unselectAll();
}
}
}
@NgModule({
imports: [
BrowserModule,
DxTreeViewModule,
DxListModule,
DxTemplateModule,
DxCheckBoxModule,
DxSelectBoxModule
],
declarations: [AppComponent, TitlePipe],
bootstrap: [AppComponent]
})
export class AppModule { }
platformBrowserDynamic().bootstrapModule(AppModule);
::ng-deep .form>h4 {
margin-bottom: 20px;
}
::ng-deep .form>div,
::ng-deep #treeview {
display: inline-block;
vertical-align: top;
}
::ng-deep .selected-container {
padding: 20px;
margin-left: 20px;
background-color: rgba(191, 191, 191, 0.15);
font-size: 115%;
font-weight: bold;
}
::ng-deep #selected-employees {
margin-top: 20px;
}
::ng-deep .dx-list-item-content {
padding-left: 0;
}
::ng-deep .options {
padding: 20px;
background-color: rgba(191, 191, 191, 0.15);
margin-top: 20px;
}
::ng-deep .caption {
font-size: 18px;
font-weight: 500;
}
::ng-deep .option {
width: 24%;
display: inline-block;
margin-top: 10px;
margin-right: 5px;
box-sizing: border-box;
}
::ng-deep .recursive-option {
padding-left: 10px;
}
::ng-deep .option:last-of-type {
margin-right: 0px;
}
import { Injectable } from '@angular/core';
export class Employee {
id: number;
fullName: string;
prefix: string;
position: string;
expanded?: boolean;
selected?: boolean;
items?: Employee[];
}
var employees: Employee[] = [{
id: 1,
fullName: "John Heart",
prefix: "Dr.",
position: "CEO",
expanded: true,
items: [{
id: 2,
fullName: "Samantha Bright",
prefix: "Dr.",
position: "COO",
expanded: true,
items: [{
id: 3,
fullName: "Kevin Carter",
prefix: "Mr.",
position: "Shipping Manager",
}, {
id: 14,
fullName: "Victor Norris",
prefix: "Mr.",
selected: true,
position: "Shipping Assistant"
}]
}, {
id: 4,
fullName: "Brett Wade",
prefix: "Mr.",
position: "IT Manager",
expanded: true,
items: [{
id: 5,
fullName: "Amelia Harper",
prefix: "Mrs.",
position: "Network Admin"
}, {
id: 6,
fullName: "Wally Hobbs",
prefix: "Mr.",
position: "Programmer"
}, {
id: 7,
fullName: "Brad Jameson",
prefix: "Mr.",
position: "Programmer"
}, {
id: 8,
fullName: "Violet Bailey",
prefix: "Ms.",
position: "Jr Graphic Designer",
}]
}, {
id: 9,
fullName: "Barb Banks",
prefix: "Mrs.",
position: "Support Manager",
expanded: true,
items: [{
id: 10,
fullName: "Kelly Rodriguez",
prefix: "Ms.",
position: "Support Assistant"
}, {
id: 11,
fullName: "James Anderson",
prefix: "Mr.",
position: "Support Assistant"
}]
}]
}];
@Injectable()
export class Service {
getEmployees(): Employee[] {
return employees;
}
}
// In real applications, you should not transpile code in the browser. You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
System.config({
transpiler: 'ts',
typescriptOptions: {
module: "system",
emitDecoratorMetadata: true,
experimentalDecorators: true
},
meta: {
'typescript': {
"exports": "ts"
},
'devextreme/localization.js': {
"esModule": true
}
},
paths: {
'npm:': 'https://unpkg.com/'
},
map: {
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@3.5.3/lib/typescript.js',
'@angular': 'npm:@angular',
'tslib': 'npm:tslib@2.0.3/tslib.js',
'rxjs': 'npm:rxjs@6.3.3',
'rrule': 'npm:rrule@2.6.6/dist/es5/rrule.js',
'luxon': 'npm:luxon@1.25.0/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign@1.1.0',
'devextreme': 'npm:devextreme@20.2.4',
'jszip': 'npm:jszip@3.5.0/dist/jszip.min.js',
'devextreme-quill': 'npm:devextreme-quill@0.9.7/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.0.5',
'devexpress-gantt': 'npm:devexpress-gantt@2.0.8',
'devextreme-angular': 'npm:devextreme-angular@20.2.4',
'preact': 'npm:preact@10.5.7/dist/preact.js',
'preact/hooks': 'npm:preact@10.5.7/hooks/dist/hooks.js'
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts'
},
'devextreme': {
defaultExtension: 'js'
},
'devextreme/events/utils': {
main: 'index'
},
'devextreme/events': {
main: 'index'
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js'
}
},
packageConfigPaths: [
"npm:@angular/*/package.json",
"npm:@angular/common/*/package.json",
"npm:rxjs/package.json",
"npm:rxjs/operators/package.json",
"npm:devextreme-angular/*/package.json",
"npm:devextreme-angular/ui/*/package.json",
"npm:devextreme-angular/package.json",
"npm:devexpress-diagram/package.json",
"npm:devexpress-gantt/package.json",
]
});
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/20.2.4/css/dx.common.css" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/20.2.4/css/dx.light.css" />
<script src="https://unpkg.com/core-js@2.4.1/client/shim.min.js"></script>
<script src="https://unpkg.com/zone.js@0.10.2/dist/zone.js"></script>
<script src="https://unpkg.com/reflect-metadata@0.1.3/Reflect.js"></script>
<script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import('app').catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>

Your search did not match any results.

Vue Tree View - Selection and Customization

To select a node, users can click a checkbox next to it. Set the showCheckBoxesMode to "normal" or "selectAll" to display node checkboxes. The "selectAll" mode also enables a checkbox that selects all nodes simultaneously. If selectByClick is enabled, users can click nodes to select them.

Backend API
<template> <div> <div class="form"> <h4>Employees</h4> <DxTreeView id="treeview" ref="treeViewRef" :width="340" :height="320" :items="employees" :show-check-boxes-mode="showCheckBoxesModeValue" :selection-mode="selectionModeValue" :select-nodes-recursive="selectNodesRecursiveValue" :select-by-click="selectByClickValue" @selection-changed="treeViewSelectionChanged" @content-ready="treeViewContentReady" > <template #item="item"> {{ item.data.fullName + ' (' + item.data.position + ')' }} </template> </DxTreeView> {{ ' ' }} <div class="selected-container">Selected employees <DxList id="selected-employees" show-scrollbar="always" :width="400" :height="200" :items="selectedEmployees" > <template #item="item"> {{ item.data.prefix + " " + item.data.fullName + " (" + item.data.position + ")" }} </template> </DxList> </div> </div> <div class="options"> <div class="caption">Options</div> <div class="options-container"> <div class="option"> <span>Show Check Boxes Mode:</span> <div class="editor-container"> <DxSelectBox :items="showCheckBoxesModes" :input-attr="{ 'aria-label': 'Show Checkboxes Mode' }" v-model:value="showCheckBoxesModeValue" @value-changed="showCheckBoxesModeValueChanged" /> </div> </div> <div class="option"> <span>Selection Mode:</span> <div class="editor-container"> <DxSelectBox :items="selectionModes" v-model:value="selectionModeValue" :input-attr="{ 'aria-label': 'Selection Mode' }" :disabled="isSelectionModeDisabled" @value-changed="selectionModeValueChanged" /> </div> </div> <div class="option"> <div class="caption-placeholder">&nbsp;</div> <div class="editor-container"> <DxCheckBox text="Select Nodes Recursive" :disabled="isRecursiveDisabled" v-model:value="selectNodesRecursiveValue" /> </div> </div> <div class="option"> <div class="caption-placeholder">&nbsp;</div> <div class="editor-container"> <DxCheckBox text="Select By Click" v-model:value="selectByClickValue" /> </div> </div> </div> </div> </div> </template> <script setup lang="ts"> import { ref } from 'vue'; import { type SingleOrMultiple } from 'devextreme-vue/common'; import DxTreeView, { type DxTreeViewTypes } from 'devextreme-vue/tree-view'; import DxList from 'devextreme-vue/list'; import DxSelectBox, { type DxSelectBoxTypes } from 'devextreme-vue/select-box'; import DxCheckBox from 'devextreme-vue/check-box'; import { employees } from './data.ts'; const selectionModes: SingleOrMultiple[] = ['multiple', 'single']; const showCheckBoxesModes: DxTreeViewTypes.TreeViewCheckBoxMode[] = ['normal', 'selectAll', 'none']; const selectedEmployees = ref([]); const showCheckBoxesModeValue = ref(showCheckBoxesModes[0]); const selectionModeValue = ref(selectionModes[0]); const isSelectionModeDisabled = ref(false); const isRecursiveDisabled = ref(false); const selectNodesRecursiveValue = ref(true); const selectByClickValue = ref(false); const treeViewRef = ref(); function treeViewSelectionChanged() { syncSelection(); } function treeViewContentReady() { syncSelection(); } function syncSelection() { selectedEmployees.value = treeViewRef.value.instance .getSelectedNodes() .map((node: DxTreeViewTypes.Node) => node.itemData); } function showCheckBoxesModeValueChanged(e: DxSelectBoxTypes.ValueChangedEvent) { if (e.value === 'selectAll') { selectionModeValue.value = 'multiple'; isRecursiveDisabled.value = false; } isSelectionModeDisabled.value = e.value === 'selectAll'; } function selectionModeValueChanged(e: DxSelectBoxTypes.ValueChangedEvent) { if (e.value === 'single') { selectNodesRecursiveValue.value = false; treeViewRef.value.instance.unselectAll(); } isRecursiveDisabled.value = e.value === 'single'; } </script> <style scoped> .form > h4 { margin-bottom: 20px; } .form > div, #treeview { display: inline-block; vertical-align: top; } .selected-container { padding: 20px; margin-left: 20px; background-color: rgba(191, 191, 191, 0.15); font-size: 115%; font-weight: bold; } #selected-employees { margin-top: 20px; } .selected-container .dx-list-item-content { padding-left: 0; } .options { padding: 20px; background-color: rgba(191, 191, 191, 0.15); margin-top: 20px; box-sizing: border-box; } .caption { font-size: 18px; font-weight: 500; } .option { width: 24%; margin-top: 10px; margin-right: 9px; box-sizing: border-box; display: flex; flex-direction: column; justify-content: center; } .options-container { display: flex; justify-content: space-between; align-items: stretch; } .editor-container { height: 100%; display: flex; align-items: center; } .editor-container > * { width: 100%; } .option:last-of-type { margin-right: 0; } </style>
window.exports = window.exports || {}; window.config = { transpiler: 'plugin-babel', meta: { '*.vue': { loader: 'vue-loader', }, '*.ts': { loader: 'demo-ts-loader', }, '*.svg': { loader: 'svg-loader', }, 'devextreme/time_zone_utils.js': { 'esModule': true, }, 'devextreme/localization.js': { 'esModule': true, }, 'devextreme/viz/palette.js': { 'esModule': true, }, 'openai': { 'esModule': true, }, }, paths: { 'project:': '../../../../', 'npm:': 'https://cdn.jsdelivr.net/npm/', 'bundles:': '../../../../bundles/', 'externals:': '../../../../bundles/externals/', }, map: { 'vue': 'npm:vue@3.4.27/dist/vue.esm-browser.js', '@vue/shared': 'npm:@vue/shared@3.4.27/dist/shared.cjs.prod.js', 'vue-loader': 'npm:dx-systemjs-vue-browser@1.1.2/index.js', 'demo-ts-loader': 'project:utils/demo-ts-loader.js', 'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js', 'svg-loader': 'project:utils/svg-loader.js', 'mitt': 'npm:mitt/dist/mitt.umd.js', 'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js', 'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js', 'es6-object-assign': 'npm:es6-object-assign', 'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs', 'devextreme-vue': 'npm:devextreme-vue@link:../../packages/devextreme-vue/npm/cjs', 'devextreme-quill': 'npm:devextreme-quill@1.7.6/dist/dx-quill.min.js', 'devexpress-diagram': 'npm:devexpress-diagram@2.2.24/dist/dx-diagram.js', 'devexpress-gantt': 'npm:devexpress-gantt@4.1.64/dist/dx-gantt.js', 'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js', 'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js', 'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js', 'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js', 'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js', 'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js', 'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js', 'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js', '@preact/signals-core': 'npm:@preact/signals-core@1.8.0/dist/signals-core.min.js', 'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js', 'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js', // Prettier 'prettier/standalone': 'npm:prettier@2.8.8/standalone.js', 'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js', }, packages: { 'devextreme-vue': { main: 'index.js', }, 'devextreme-vue/common': { main: 'index.js', }, 'devextreme': { defaultExtension: 'js', }, 'devextreme/events/utils': { main: 'index', }, 'devextreme/common/core/events/utils': { main: 'index', }, 'devextreme/events': { main: 'index', }, 'es6-object-assign': { main: './index.js', defaultExtension: 'js', }, }, packageConfigPaths: [ 'npm:@devextreme/*/package.json', ], babelOptions: { sourceMaps: false, stage0: true, }, }; System.config(window.config); // eslint-disable-next-line const useTgzInCSB = ['openai'];
export const employees = [{ id: 1, fullName: 'John Heart', prefix: 'Dr.', position: 'CEO', expanded: true, items: [{ id: 2, fullName: 'Samantha Bright', prefix: 'Dr.', position: 'COO', expanded: true, items: [{ id: 3, fullName: 'Kevin Carter', prefix: 'Mr.', position: 'Shipping Manager', }, { id: 14, fullName: 'Victor Norris', prefix: 'Mr.', selected: true, position: 'Shipping Assistant', }], }, { id: 4, fullName: 'Brett Wade', prefix: 'Mr.', position: 'IT Manager', expanded: true, items: [{ id: 5, fullName: 'Amelia Harper', prefix: 'Mrs.', position: 'Network Admin', }, { id: 6, fullName: 'Wally Hobbs', prefix: 'Mr.', position: 'Programmer', }, { id: 7, fullName: 'Brad Jameson', prefix: 'Mr.', position: 'Programmer', }, { id: 8, fullName: 'Violet Bailey', prefix: 'Ms.', position: 'Jr Graphic Designer', }], }, { id: 9, fullName: 'Barb Banks', prefix: 'Mrs.', position: 'Support Manager', expanded: true, items: [{ id: 10, fullName: 'Kelly Rodriguez', prefix: 'Ms.', position: 'Support Assistant', }, { id: 11, fullName: 'James Anderson', prefix: 'Mr.', position: 'Support Assistant', }], }], }];
import { createApp } from 'vue'; import App from './App.vue'; createApp(App).mount('#app');
<!DOCTYPE html> <html lang="en"> <head> <title>DevExtreme Demo</title> <meta http-equiv="X-UA-Compatible" content="IE=edge" /> <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" /> <link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.1.7/css/dx.light.css" /> <script src="https://cdn.jsdelivr.net/npm/typescript@5.4.5/lib/typescript.js"></script> <script type="module"> import * as vueCompilerSFC from "https://cdn.jsdelivr.net/npm/@vue/compiler-sfc@3.4.27/dist/compiler-sfc.esm-browser.js"; window.vueCompilerSFC = vueCompilerSFC; </script> <script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script> <script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script> <script type="text/javascript" src="config.js"></script> <script type="text/javascript"> System.import("./index.ts"); </script> </head> <body class="dx-viewport"> <div class="demo-container"> <div id="app"> </div> </div> </body> </html>

Use the following TreeView properties to adjust selection:

  • selectionMode
    Specifies whether multiple node selection is allowed.

  • selectNodesRecursive
    Specifies whether nested nodes are selected together with their parent.

  • selectedExpr
    A data field that allows you to pre-select a node. In this demo, the data field is called selected, and it is set to true for the "Victor Norris" node (see the data source).

  • onSelectionChanged
    A function that allows you to handle selection changes. In this demo, it is used to synchronize the List with the TreeView.

The TreeView also provides the following methods to manage selection programmatically:

This demo also shows how to specify an itemTemplate for node customization. Node data is passed to the template as an argument.

import React from 'react';
import TreeView from 'devextreme-react/tree-view';
import List from 'devextreme-react/list';
import SelectBox from 'devextreme-react/select-box';
import CheckBox from 'devextreme-react/check-box';
import { employees } from './data.js';
class App extends React.Component {
constructor() {
super();
this.treeViewRef = React.createRef();
const showCheckBoxesModes = ['normal', 'selectAll', 'none'];
const selectionModes = ['multiple', 'single'];
const showCheckBoxesMode = showCheckBoxesModes[0];
const selectionMode = selectionModes[0];
this.state = {
employees,
selectedEmployees: [],
selectNodesRecursive: true,
selectByClick: false,
showCheckBoxesModes,
showCheckBoxesMode,
selectionModes,
selectionMode,
isSelectionModeDisabled: false,
isRecursiveDisabled: false
};
this.treeViewSelectionChanged = this.treeViewSelectionChanged.bind(this);
this.treeViewContentReady = this.treeViewContentReady.bind(this);
this.showCheckBoxesModeValueChanged = this.showCheckBoxesModeValueChanged.bind(this);
this.selectionModeValueChanged = this.selectionModeValueChanged.bind(this);
this.selectNodesRecursiveValueChanged = this.selectNodesRecursiveValueChanged.bind(this);
this.selectByClickValueChanged = this.selectByClickValueChanged.bind(this);
}
render() {
return (
<div>
<div className="form">
<h4>Employees</h4>
<TreeView
id="treeview"
ref={this.treeViewRef}
width={340}
height={320}
items={this.state.employees}
selectNodesRecursive={this.state.selectNodesRecursive}
selectByClick={this.state.selectByClick}
showCheckBoxesMode={this.state.showCheckBoxesMode}
selectionMode={this.state.selectionMode}
onSelectionChanged={this.treeViewSelectionChanged}
onContentReady={this.treeViewContentReady}
itemRender={renderTreeViewItem}
/>
{' '}
<div className="selected-container">Selected employees
<List
id="selected-employees"
width={400}
height={200}
showScrollbar="always"
items={this.state.selectedEmployees}
itemRender={renderListItem}
/>
</div>
</div>
<div className="options">
<div className="caption">Options</div>
<div className="option">
<span>Show Check Boxes Mode:</span>
<SelectBox
items={this.state.showCheckBoxesModes}
value={this.state.showCheckBoxesMode}
onValueChanged={this.showCheckBoxesModeValueChanged} />
</div>
<div className="option">
<span>Selection Mode:</span>
<SelectBox
items={this.state.selectionModes}
value={this.state.selectionMode}
disabled={this.state.isSelectionModeDisabled}
onValueChanged={this.selectionModeValueChanged} />
</div>
<div className="option recursive-option">
<CheckBox
text="Select Nodes Recursive"
value={this.state.selectNodesRecursive}
disabled={this.state.isRecursiveDisabled}
onValueChanged={this.selectNodesRecursiveValueChanged} />
</div>
<div className="option">
<CheckBox
text="Select By Click"
value={this.state.selectByClick}
onValueChanged={this.selectByClickValueChanged} />
</div>
</div>
</div>
);
}
treeViewSelectionChanged(e) {
this.syncSelection(e.component);
}
treeViewContentReady(e) {
this.syncSelection(e.component);
}
syncSelection(treeView) {
const selectedEmployees = treeView.getSelectedNodes()
.map((node) => node.itemData);
this.setState(() => {
return { selectedEmployees: selectedEmployees };
});
}
showCheckBoxesModeValueChanged(e) {
let state = { showCheckBoxesMode: e.value };
if(e.value === 'selectAll') {
state.selectionMode = 'multiple';
state.isRecursiveDisabled = false;
}
state.isSelectionModeDisabled = e.value === 'selectAll';
this.setState(state);
}
selectionModeValueChanged(e) {
let state = { selectionMode: e.value };
if(e.value === 'single') {
state.selectNodesRecursive = false;
this.treeView.unselectAll();
}
state.isRecursiveDisabled = e.value === 'single';
this.setState(state);
}
selectNodesRecursiveValueChanged(e) {
this.setState({ selectNodesRecursive: e.value });
}
selectByClickValueChanged(e) {
this.setState({ selectByClick: e.value });
}
get treeView() {
return this.treeViewRef.current.instance;
}
}
function renderTreeViewItem(item) {
return `${item.fullName} (${item.position})`;
}
function renderListItem(item) {
return `${item.prefix} ${item.fullName} (${item.position})`;
}
export default App;
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(
<App />,
document.getElementById('app')
);
<!DOCTYPE html>
<html>
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/20.2.4/css/dx.common.css" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/20.2.4/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://unpkg.com/core-js@2.4.1/client/shim.min.js"></script>
<script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import('./index.js');
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
.form>h4 {
margin-bottom: 20px;
}
.form>div,
#treeview {
display: inline-block;
vertical-align: top;
}
#selected-employees {
margin-top: 20px;
}
.selected-container {
padding: 20px;
margin-left: 20px;
background-color: rgba(191, 191, 191, 0.15);
font-size: 115%;
font-weight: bold;
}
.dx-list-item-content {
padding-left: 0;
}
.options {
padding: 20px;
background-color: rgba(191, 191, 191, 0.15);
margin-top: 20px;
box-sizing: border-box;
}
.caption {
font-size: 18px;
font-weight: 500;
}
.option {
width: 24%;
display: inline-block;
margin-top: 10px;
margin-right: 5px;
box-sizing: border-box;
}
.recursive-option {
padding-left: 10px;
}
.option:last-of-type {
margin-right: 0px;
}
export const employees = [{
id: 1,
fullName: 'John Heart',
prefix: 'Dr.',
position: 'CEO',
expanded: true,
items: [{
id: 2,
fullName: 'Samantha Bright',
prefix: 'Dr.',
position: 'COO',
expanded: true,
items: [{
id: 3,
fullName: 'Kevin Carter',
prefix: 'Mr.',
position: 'Shipping Manager',
}, {
id: 14,
fullName: 'Victor Norris',
prefix: 'Mr.',
selected: true,
position: 'Shipping Assistant'
}]
}, {
id: 4,
fullName: 'Brett Wade',
prefix: 'Mr.',
position: 'IT Manager',
expanded: true,
items: [{
id: 5,
fullName: 'Amelia Harper',
prefix: 'Mrs.',
position: 'Network Admin'
}, {
id: 6,
fullName: 'Wally Hobbs',
prefix: 'Mr.',
position: 'Programmer'
}, {
id: 7,
fullName: 'Brad Jameson',
prefix: 'Mr.',
position: 'Programmer'
}, {
id: 8,
fullName: 'Violet Bailey',
prefix: 'Ms.',
position: 'Jr Graphic Designer',
}]
}, {
id: 9,
fullName: 'Barb Banks',
prefix: 'Mrs.',
position: 'Support Manager',
expanded: true,
items: [{
id: 10,
fullName: 'Kelly Rodriguez',
prefix: 'Ms.',
position: 'Support Assistant'
}, {
id: 11,
fullName: 'James Anderson',
prefix: 'Mr.',
position: 'Support Assistant'
}]
}]
}];
System.config({
transpiler: 'plugin-babel',
meta: {
},
paths: {
'npm:': 'https://unpkg.com/'
},
defaultExtension: 'js',
map: {
'react': 'npm:react@16.14.0/umd/react.development.js',
'react-dom': 'npm:react-dom@16.14.0/umd/react-dom.development.js',
'prop-types': 'npm:prop-types@15.7.2/prop-types.js',
'rrule': 'npm:rrule@2.6.6/dist/es5/rrule.js',
'luxon': 'npm:luxon@1.25.0/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign@1.1.0',
'devextreme': 'npm:devextreme@20.2.4',
'devextreme-react': 'npm:devextreme-react@20.2.4',
'jszip': 'npm:jszip@3.5.0/dist/jszip.min.js',
'devextreme-quill': 'npm:devextreme-quill@0.9.7/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.0.5/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@2.0.8/dist/dx-gantt.js',
'preact': 'npm:preact@10.5.7/dist/preact.js',
'preact/hooks': 'npm:preact@10.5.7/hooks/dist/hooks.js',
// SystemJS plugins
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js'
},
packages: {
'devextreme': {
defaultExtension: 'js'
},
'devextreme-react': {
main: 'index.js'
},
'devextreme/events/utils': {
main: 'index'
},
'devextreme/events': {
main: 'index'
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js'
}
},
babelOptions: {
sourceMaps: false,
stage0: true,
react: true
}
});